diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/vht/vht-ppdu.cc ns-3.34/src/wifi/model/vht/vht-ppdu.cc
--- ns-3.33/src/wifi/model/vht/vht-ppdu.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/vht/vht-ppdu.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,303 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2019 Orange Labs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Rediet <getachew.redieteab@orange.com>
+ *         Muhammad Iqbal Rochman <muhiqbalcr@uchicago.edu>
+ *         Sébastien Deronne <sebastien.deronne@gmail.com> (VhtSigHeader)
+ */
+
+#include "ns3/wifi-phy.h"
+#include "ns3/wifi-psdu.h"
+#include "vht-phy.h"
+#include "vht-ppdu.h"
+#include "ns3/log.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("VhtPpdu");
+
+VhtPpdu::VhtPpdu (Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, Time ppduDuration,
+                  WifiPhyBand band, uint64_t uid)
+  : OfdmPpdu (psdu, txVector, band, uid, false) //don't instantiate LSigHeader of OfdmPpdu
+{
+  NS_LOG_FUNCTION (this << psdu << txVector << ppduDuration << band << uid);
+  uint16_t length = ((ceil ((static_cast<double> (ppduDuration.GetNanoSeconds () - (20 * 1000)) / 1000) / 4.0) * 3) - 3);
+  m_lSig.SetLength (length);
+  m_vhtSig.SetMuFlag (m_preamble == WIFI_PREAMBLE_VHT_MU);
+  m_vhtSig.SetChannelWidth (m_channelWidth);
+  m_vhtSig.SetShortGuardInterval (txVector.GetGuardInterval () == 400);
+  uint32_t nSymbols = (static_cast<double> ((ppduDuration - WifiPhy::CalculatePhyPreambleAndHeaderDuration (txVector)).GetNanoSeconds ()) / (3200 + txVector.GetGuardInterval ()));
+  if (txVector.GetGuardInterval () == 400)
+    {
+      m_vhtSig.SetShortGuardIntervalDisambiguation ((nSymbols % 10) == 9);
+    }
+  m_vhtSig.SetSuMcs (txVector.GetMode ().GetMcsValue ());
+  m_vhtSig.SetNStreams (txVector.GetNss ());
+}
+
+VhtPpdu::~VhtPpdu ()
+{
+}
+
+WifiTxVector
+VhtPpdu::DoGetTxVector (void) const
+{
+  WifiTxVector txVector;
+  txVector.SetPreambleType (m_preamble);
+  txVector.SetMode (VhtPhy::GetVhtMcs (m_vhtSig.GetSuMcs ()));
+  txVector.SetChannelWidth (m_vhtSig.GetChannelWidth ());
+  txVector.SetNss (m_vhtSig.GetNStreams ());
+  txVector.SetGuardInterval (m_vhtSig.GetShortGuardInterval () ? 400 : 800);
+  txVector.SetAggregation (GetPsdu ()->IsAggregate ());
+  return txVector;
+}
+
+Time
+VhtPpdu::GetTxDuration (void) const
+{
+  Time ppduDuration = Seconds (0);
+  const WifiTxVector& txVector = GetTxVector ();
+  Time tSymbol = NanoSeconds (3200 + txVector.GetGuardInterval ());
+  Time preambleDuration = WifiPhy::CalculatePhyPreambleAndHeaderDuration (txVector);
+  Time calculatedDuration = MicroSeconds (((ceil (static_cast<double> (m_lSig.GetLength () + 3) / 3)) * 4) + 20);
+  uint32_t nSymbols = floor (static_cast<double> ((calculatedDuration - preambleDuration).GetNanoSeconds ()) / tSymbol.GetNanoSeconds ());
+  if (m_vhtSig.GetShortGuardInterval () && m_vhtSig.GetShortGuardIntervalDisambiguation ())
+    {
+      nSymbols--;
+    }
+  ppduDuration = preambleDuration + (nSymbols * tSymbol);
+  return ppduDuration;
+}
+
+Ptr<WifiPpdu>
+VhtPpdu::Copy (void) const
+{
+  return Create<VhtPpdu> (GetPsdu (), GetTxVector (), GetTxDuration (), m_band, m_uid);
+}
+
+WifiPpduType
+VhtPpdu::GetType (void) const
+{
+  return (m_preamble == WIFI_PREAMBLE_VHT_MU) ? WIFI_PPDU_TYPE_DL_MU : WIFI_PPDU_TYPE_SU;
+}
+
+VhtPpdu::VhtSigHeader::VhtSigHeader ()
+  : m_bw (0),
+    m_nsts (0),
+    m_sgi (0),
+    m_sgi_disambiguation (0),
+    m_suMcs (0),
+    m_mu (false)
+{
+}
+
+VhtPpdu::VhtSigHeader::~VhtSigHeader ()
+{
+}
+
+TypeId
+VhtPpdu::VhtSigHeader::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::VhtSigHeader")
+    .SetParent<Header> ()
+    .SetGroupName ("Wifi")
+    .AddConstructor<VhtSigHeader> ()
+  ;
+  return tid;
+}
+
+TypeId
+VhtPpdu::VhtSigHeader::GetInstanceTypeId (void) const
+{
+  return GetTypeId ();
+}
+
+void
+VhtPpdu::VhtSigHeader::Print (std::ostream &os) const
+{
+  os << "SU_MCS=" << +m_suMcs
+     << " CHANNEL_WIDTH=" << GetChannelWidth ()
+     << " SGI=" << +m_sgi
+     << " NSTS=" << +m_nsts
+     << " MU=" << +m_mu;
+}
+
+uint32_t
+VhtPpdu::VhtSigHeader::GetSerializedSize (void) const
+{
+  uint32_t size = 0;
+  size += 3; //VHT-SIG-A1
+  size += 3; //VHT-SIG-A2
+  if (m_mu)
+    {
+      size += 4; //VHT-SIG-B
+    }
+  return size;
+}
+
+void
+VhtPpdu::VhtSigHeader::SetMuFlag (bool mu)
+{
+  m_mu = mu;
+}
+
+void
+VhtPpdu::VhtSigHeader::SetChannelWidth (uint16_t channelWidth)
+{
+  if (channelWidth == 160)
+    {
+      m_bw = 3;
+    }
+  else if (channelWidth == 80)
+    {
+      m_bw = 2;
+    }
+  else if (channelWidth == 40)
+    {
+      m_bw = 1;
+    }
+  else
+    {
+      m_bw = 0;
+    }
+}
+
+uint16_t
+VhtPpdu::VhtSigHeader::GetChannelWidth (void) const
+{
+  if (m_bw == 3)
+    {
+      return 160;
+    }
+  else if (m_bw == 2)
+    {
+      return 80;
+    }
+  else if (m_bw == 1)
+    {
+      return 40;
+    }
+  else
+    {
+      return 20;
+    }
+}
+
+void
+VhtPpdu::VhtSigHeader::SetNStreams (uint8_t nStreams)
+{
+  NS_ASSERT (nStreams <= 8);
+  m_nsts = (nStreams - 1);
+}
+
+uint8_t
+VhtPpdu::VhtSigHeader::GetNStreams (void) const
+{
+  return (m_nsts + 1);
+}
+
+void
+VhtPpdu::VhtSigHeader::SetShortGuardInterval (bool sgi)
+{
+  m_sgi = sgi ? 1 : 0;
+}
+
+bool
+VhtPpdu::VhtSigHeader::GetShortGuardInterval (void) const
+{
+  return m_sgi ? true : false;
+}
+
+void
+VhtPpdu::VhtSigHeader::SetShortGuardIntervalDisambiguation (bool disambiguation)
+{
+  m_sgi_disambiguation = disambiguation ? 1 : 0;
+}
+
+bool
+VhtPpdu::VhtSigHeader::GetShortGuardIntervalDisambiguation (void) const
+{
+  return m_sgi_disambiguation ? true : false;
+}
+
+void
+VhtPpdu::VhtSigHeader::SetSuMcs (uint8_t mcs)
+{
+  NS_ASSERT (mcs <= 9);
+  m_suMcs = mcs;
+}
+
+uint8_t
+VhtPpdu::VhtSigHeader::GetSuMcs (void) const
+{
+  return m_suMcs;
+}
+
+void
+VhtPpdu::VhtSigHeader::Serialize (Buffer::Iterator start) const
+{
+  //VHT-SIG-A1
+  uint8_t byte = m_bw;
+  byte |= (0x01 << 2); //Set Reserved bit #2 to 1
+  start.WriteU8 (byte);
+  uint16_t bytes = (m_nsts & 0x07) << 2;
+  bytes |= (0x01 << (23 - 8)); //Set Reserved bit #23 to 1
+  start.WriteU16 (bytes);
+
+  //VHT-SIG-A2
+  byte = m_sgi & 0x01;
+  byte |= ((m_sgi_disambiguation & 0x01) << 1);
+  byte |= ((m_suMcs & 0x0f) << 4);
+  start.WriteU8 (byte);
+  bytes = (0x01 << (9 - 8)); //Set Reserved bit #9 to 1
+  start.WriteU16 (bytes);
+
+  if (m_mu)
+    {
+      //VHT-SIG-B
+      start.WriteU32 (0);
+    }
+}
+
+uint32_t
+VhtPpdu::VhtSigHeader::Deserialize (Buffer::Iterator start)
+{
+  Buffer::Iterator i = start;
+
+  //VHT-SIG-A1
+  uint8_t byte = i.ReadU8 ();
+  m_bw = byte & 0x03;
+  uint16_t bytes = i.ReadU16 ();
+  m_nsts = ((bytes >> 2) & 0x07);
+
+  //VHT-SIG-A2
+  byte = i.ReadU8 ();
+  m_sgi = byte & 0x01;
+  m_sgi_disambiguation = ((byte >> 1) & 0x01);
+  m_suMcs = ((byte >> 4) & 0x0f);
+  i.ReadU16 ();
+
+  if (m_mu)
+    {
+      //VHT-SIG-B
+      i.ReadU32 ();
+    }
+
+  return i.GetDistanceFrom (start);
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/vht/vht-ppdu.h ns-3.34/src/wifi/model/vht/vht-ppdu.h
--- ns-3.33/src/wifi/model/vht/vht-ppdu.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/vht/vht-ppdu.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,181 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2019 Orange Labs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Rediet <getachew.redieteab@orange.com>
+ *         Muhammad Iqbal Rochman <muhiqbalcr@uchicago.edu>
+ *         Sébastien Deronne <sebastien.deronne@gmail.com> (VhtSigHeader)
+ */
+
+#ifndef VHT_PPDU_H
+#define VHT_PPDU_H
+
+#include "ns3/ofdm-ppdu.h"
+
+/**
+ * \file
+ * \ingroup wifi
+ * Declaration of ns3::VhtPpdu class.
+ */
+
+namespace ns3 {
+
+class WifiPsdu;
+
+/**
+ * \brief VHT PPDU (11ac)
+ * \ingroup wifi
+ *
+ * VhtPpdu stores a preamble, PHY headers and a PSDU of a PPDU with VHT header
+ */
+class VhtPpdu : public OfdmPpdu
+{
+public:
+
+  /**
+   * VHT PHY header (VHT-SIG-A1/A2/B).
+   * See section 21.3.8 in IEEE 802.11-2016.
+   */
+  class VhtSigHeader : public Header
+  {
+  public:
+    VhtSigHeader ();
+    virtual ~VhtSigHeader ();
+
+    /**
+     * \brief Get the type ID.
+     * \return the object TypeId
+     */
+    static TypeId GetTypeId (void);
+
+    TypeId GetInstanceTypeId (void) const override;
+    void Print (std::ostream &os) const override;
+    uint32_t GetSerializedSize (void) const override;
+    void Serialize (Buffer::Iterator start) const override;
+    uint32_t Deserialize (Buffer::Iterator start) override;
+
+    /**
+     * Set the Multi-User (MU) flag.
+     *
+     * \param mu the MU flag
+     */
+    void SetMuFlag (bool mu);
+
+    /**
+     * Fill the channel width field of VHT-SIG-A1 (in MHz).
+     *
+     * \param channelWidth the channel width (in MHz)
+     */
+    void SetChannelWidth (uint16_t channelWidth);
+    /**
+     * Return the channel width (in MHz).
+     *
+     * \return the channel width (in MHz)
+     */
+    uint16_t GetChannelWidth (void) const;
+    /**
+     * Fill the number of streams field of VHT-SIG-A1.
+     *
+     * \param nStreams the number of streams
+     */
+    void SetNStreams (uint8_t nStreams);
+    /**
+     * Return the number of streams.
+     *
+     * \return the number of streams
+     */
+    uint8_t GetNStreams (void) const;
+
+    /**
+     * Fill the short guard interval field of VHT-SIG-A2.
+     *
+     * \param sgi whether short guard interval is used or not
+     */
+    void SetShortGuardInterval (bool sgi);
+    /**
+     * Return the short GI field of VHT-SIG-A2.
+     *
+     * \return the short GI field of VHT-SIG-A2
+     */
+    bool GetShortGuardInterval (void) const;
+    /**
+     * Fill the short GI NSYM disambiguation field of VHT-SIG-A2.
+     *
+     * \param disambiguation whether short GI NSYM disambiguation is set or not
+     */
+    void SetShortGuardIntervalDisambiguation (bool disambiguation);
+    /**
+     * Return the short GI NSYM disambiguation field of VHT-SIG-A2.
+     *
+     * \return the short GI NSYM disambiguation field of VHT-SIG-A2
+     */
+    bool GetShortGuardIntervalDisambiguation (void) const;
+    /**
+     * Fill the SU VHT MCS field of VHT-SIG-A2.
+     *
+     * \param mcs the SU VHT MCS field of VHT-SIG-A2
+     */
+    void SetSuMcs (uint8_t mcs);
+    /**
+     * Return the SU VHT MCS field of VHT-SIG-A2.
+     *
+     * \return the SU VHT MCS field of VHT-SIG-A2
+     */
+    uint8_t GetSuMcs (void) const;
+
+  private:
+    //VHT-SIG-A1 fields
+    uint8_t m_bw;   ///< BW
+    uint8_t m_nsts; ///< NSTS
+
+    //VHT-SIG-A2 fields
+    uint8_t m_sgi;                ///< Short GI
+    uint8_t m_sgi_disambiguation; ///< Short GI NSYM Disambiguation
+    uint8_t m_suMcs;              ///< SU VHT MCS
+
+    /// This is used to decide whether MU SIG-B should be added or not
+    bool m_mu;
+  }; //class VhtSigHeader
+
+  /**
+   * Create a VHT PPDU.
+   *
+   * \param psdu the PHY payload (PSDU)
+   * \param txVector the TXVECTOR that was used for this PPDU
+   * \param ppduDuration the transmission duration of this PPDU
+   * \param band the WifiPhyBand used for the transmission of this PPDU
+   * \param uid the unique ID of this PPDU
+   */
+  VhtPpdu (Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, Time ppduDuration,
+           WifiPhyBand band, uint64_t uid);
+  /**
+   * Destructor for VhtPpdu.
+   */
+  virtual ~VhtPpdu ();
+
+  Time GetTxDuration (void) const override;
+  Ptr<WifiPpdu> Copy (void) const override;
+  WifiPpduType GetType (void) const override;
+
+private:
+  WifiTxVector DoGetTxVector (void) const override;
+
+  VhtSigHeader m_vhtSig;  //!< the VHT-SIG PHY header
+}; //class VhtPpdu
+
+} //namespace ns3
+
+#endif /* VHT_PPDU_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-ack-manager.cc ns-3.34/src/wifi/model/wifi-ack-manager.cc
--- ns-3.33/src/wifi/model/wifi-ack-manager.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-ack-manager.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,97 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "ns3/log.h"
+#include "wifi-ack-manager.h"
+#include "wifi-psdu.h"
+#include "regular-wifi-mac.h"
+
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("WifiAckManager");
+
+NS_OBJECT_ENSURE_REGISTERED (WifiAckManager);
+
+TypeId
+WifiAckManager::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::WifiAckManager")
+    .SetParent<Object> ()
+    .SetGroupName ("Wifi")
+  ;
+  return tid;
+}
+
+WifiAckManager::~WifiAckManager ()
+{
+  NS_LOG_FUNCTION_NOARGS ();
+}
+
+void
+WifiAckManager::DoDispose (void)
+{
+  NS_LOG_FUNCTION (this);
+  m_mac = 0;
+  Object::DoDispose ();
+}
+
+void
+WifiAckManager::SetWifiMac (Ptr<RegularWifiMac> mac)
+{
+  NS_LOG_FUNCTION (this << mac);
+  m_mac = mac;
+}
+
+void
+WifiAckManager::SetQosAckPolicy (Ptr<WifiMacQueueItem> item, const WifiAcknowledgment* acknowledgment)
+{
+  NS_LOG_FUNCTION (*item << acknowledgment);
+
+  WifiMacHeader& hdr = item->GetHeader ();
+  if (!hdr.IsQosData ())
+    {
+      return;
+    }
+  NS_ASSERT (acknowledgment != nullptr);
+
+  hdr.SetQosAckPolicy (acknowledgment->GetQosAckPolicy (hdr.GetAddr1 (), hdr.GetQosTid ()));
+}
+
+void
+WifiAckManager::SetQosAckPolicy (Ptr<WifiPsdu> psdu, const WifiAcknowledgment* acknowledgment)
+{
+  NS_LOG_FUNCTION (*psdu << acknowledgment);
+
+  if (psdu->GetNMpdus () == 1)
+    {
+      SetQosAckPolicy (*psdu->begin (), acknowledgment);
+      return;
+    }
+
+  NS_ASSERT (acknowledgment != nullptr);
+
+  for (const auto& tid : psdu->GetTids ())
+    {
+      psdu->SetAckPolicyForTid (tid, acknowledgment->GetQosAckPolicy (psdu->GetAddr1 (), tid));
+    }
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-ack-manager.h ns-3.34/src/wifi/model/wifi-ack-manager.h
--- ns-3.33/src/wifi/model/wifi-ack-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-ack-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,111 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef WIFI_ACK_MANAGER_H
+#define WIFI_ACK_MANAGER_H
+
+#include "wifi-acknowledgment.h"
+#include <memory>
+#include "ns3/object.h"
+
+
+namespace ns3 {
+
+class WifiTxParameters;
+class WifiMacQueueItem;
+class WifiPsdu;
+class RegularWifiMac;
+
+/**
+ * \ingroup wifi
+ *
+ * WifiAckManager is an abstract base class. Each subclass defines a logic
+ * to select the acknowledgment method for a given frame.
+ */
+class WifiAckManager : public Object
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  virtual ~WifiAckManager ();
+
+  /**
+   * Set the MAC which is using this Acknowledgment Manager
+   *
+   * \param mac a pointer to the MAC
+   */
+  void SetWifiMac (Ptr<RegularWifiMac> mac);
+
+  /**
+   * Set the QoS Ack policy for the given MPDU, which must be a QoS data frame.
+   *
+   * \param item the MPDU
+   * \param acknowledgment the WifiAcknowledgment object storing the QoS Ack policy to set
+   */
+  static void SetQosAckPolicy (Ptr<WifiMacQueueItem> item, const WifiAcknowledgment* acknowledgment);
+
+  /**
+   * Set the QoS Ack policy for the given PSDU, which must include at least a QoS data frame.
+   *
+   * \param psdu the PSDU
+   * \param acknowledgment the WifiAcknowledgment object storing the QoS Ack policy to set
+   */
+  static void SetQosAckPolicy (Ptr<WifiPsdu> psdu, const WifiAcknowledgment* acknowledgment);
+
+  /**
+   * Determine the acknowledgment method to use if the given MPDU is added to the current
+   * frame. Return a null pointer if the acknowledgment method is unchanged or the new
+   * acknowledgment method otherwise.
+   *
+   * \param mpdu the MPDU to be added to the current frame
+   * \param txParams the current TX parameters for the current frame
+   * \return a null pointer if the acknowledgment method is unchanged or the new
+   *         acknowledgment method otherwise
+   */
+  virtual std::unique_ptr<WifiAcknowledgment> TryAddMpdu (Ptr<const WifiMacQueueItem> mpdu,
+                                                          const WifiTxParameters& txParams) = 0;
+
+  /**
+   * Determine the acknowledgment method to use if the given MSDU is aggregated to the current
+   * frame. Return a null pointer if the acknowledgment method is unchanged or the new
+   * acknowledgment method otherwise.
+   *
+   * \param msdu the MSDU to be aggregated to the current frame
+   * \param txParams the current TX parameters for the current frame
+   * \return a null pointer if the acknowledgment method is unchanged or the new
+   *         acknowledgment method otherwise
+   */
+  virtual std::unique_ptr<WifiAcknowledgment> TryAggregateMsdu (Ptr<const WifiMacQueueItem> msdu,
+                                                                const WifiTxParameters& txParams) = 0;
+
+protected:
+  void DoDispose (void) override;
+
+  Ptr<RegularWifiMac> m_mac;     //!< MAC which is using this Acknowledgment Manager
+};
+
+
+
+} //namespace ns3
+
+#endif /* WIFI_ACK_MANAGER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-acknowledgment.cc ns-3.34/src/wifi/model/wifi-acknowledgment.cc
--- ns-3.33/src/wifi/model/wifi-acknowledgment.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-acknowledgment.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,407 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "wifi-acknowledgment.h"
+#include "wifi-utils.h"
+#include "ns3/mac48-address.h"
+
+namespace ns3 {
+
+/*
+ * WifiAcknowledgment
+ */
+
+WifiAcknowledgment::WifiAcknowledgment (Method m)
+  : method (m),
+    acknowledgmentTime (Time::Min ())   // uninitialized
+{
+}
+
+WifiAcknowledgment::~WifiAcknowledgment ()
+{
+}
+
+WifiMacHeader::QosAckPolicy
+WifiAcknowledgment::GetQosAckPolicy (Mac48Address receiver, uint8_t tid) const
+{
+  auto it = m_ackPolicy.find ({receiver, tid});
+  NS_ASSERT (it != m_ackPolicy.end ());
+  return it->second;
+}
+
+void
+WifiAcknowledgment::SetQosAckPolicy (Mac48Address receiver, uint8_t tid,
+                                     WifiMacHeader::QosAckPolicy ackPolicy)
+{
+  NS_ABORT_MSG_IF (!CheckQosAckPolicy (receiver, tid, ackPolicy), "QoS Ack policy not admitted");
+  m_ackPolicy[{receiver, tid}] = ackPolicy;
+}
+
+/*
+ * WifiNoAck
+ */
+
+WifiNoAck::WifiNoAck ()
+  : WifiAcknowledgment (NONE)
+{
+  acknowledgmentTime = Seconds (0);
+}
+
+std::unique_ptr<WifiAcknowledgment>
+WifiNoAck::Copy (void) const
+{
+  return std::unique_ptr<WifiAcknowledgment> (new WifiNoAck (*this));
+}
+
+bool
+WifiNoAck::CheckQosAckPolicy (Mac48Address receiver, uint8_t tid, WifiMacHeader::QosAckPolicy ackPolicy) const
+{
+  if (ackPolicy == WifiMacHeader::NO_ACK || ackPolicy == WifiMacHeader::BLOCK_ACK)
+    {
+      return true;
+    }
+  return false;
+}
+
+void
+WifiNoAck::Print (std::ostream &os) const
+{
+  os << "NONE";
+}
+
+
+/*
+ * WifiNormalAck
+ */
+
+WifiNormalAck::WifiNormalAck ()
+  : WifiAcknowledgment (NORMAL_ACK)
+{
+}
+
+std::unique_ptr<WifiAcknowledgment>
+WifiNormalAck::Copy (void) const
+{
+  return std::unique_ptr<WifiAcknowledgment> (new WifiNormalAck (*this));
+}
+
+bool
+WifiNormalAck::CheckQosAckPolicy (Mac48Address receiver, uint8_t tid, WifiMacHeader::QosAckPolicy ackPolicy) const
+{
+  if (ackPolicy == WifiMacHeader::NORMAL_ACK)
+    {
+      return true;
+    }
+  return false;
+}
+
+void
+WifiNormalAck::Print (std::ostream &os) const
+{
+  os << "NORMAL_ACK";
+}
+
+/*
+ * WifiBlockAck
+ */
+
+WifiBlockAck::WifiBlockAck ()
+  : WifiAcknowledgment (BLOCK_ACK)
+{
+}
+
+std::unique_ptr<WifiAcknowledgment>
+WifiBlockAck::Copy (void) const
+{
+  return std::unique_ptr<WifiAcknowledgment> (new WifiBlockAck (*this));
+}
+
+bool
+WifiBlockAck::CheckQosAckPolicy (Mac48Address receiver, uint8_t tid, WifiMacHeader::QosAckPolicy ackPolicy) const
+{
+  if (ackPolicy == WifiMacHeader::NORMAL_ACK)
+    {
+      return true;
+    }
+  return false;
+}
+
+void
+WifiBlockAck::Print (std::ostream &os) const
+{
+  os << "BLOCK_ACK";
+}
+
+
+/*
+ * WifiBarBlockAck
+ */
+
+WifiBarBlockAck::WifiBarBlockAck ()
+  : WifiAcknowledgment (BAR_BLOCK_ACK)
+{
+}
+
+std::unique_ptr<WifiAcknowledgment>
+WifiBarBlockAck::Copy (void) const
+{
+  return std::unique_ptr<WifiAcknowledgment> (new WifiBarBlockAck (*this));
+}
+
+bool
+WifiBarBlockAck::CheckQosAckPolicy (Mac48Address receiver, uint8_t tid, WifiMacHeader::QosAckPolicy ackPolicy) const
+{
+  if (ackPolicy == WifiMacHeader::BLOCK_ACK)
+    {
+      return true;
+    }
+  return false;
+}
+
+void
+WifiBarBlockAck::Print (std::ostream &os) const
+{
+  os << "BAR_BLOCK_ACK";
+}
+
+
+/*
+ * WifiDlMuBarBaSequence
+ */
+
+WifiDlMuBarBaSequence::WifiDlMuBarBaSequence ()
+  : WifiAcknowledgment (DL_MU_BAR_BA_SEQUENCE)
+{
+}
+
+std::unique_ptr<WifiAcknowledgment>
+WifiDlMuBarBaSequence::Copy (void) const
+{
+  return std::unique_ptr<WifiAcknowledgment> (new WifiDlMuBarBaSequence (*this));
+}
+
+bool
+WifiDlMuBarBaSequence::CheckQosAckPolicy (Mac48Address receiver, uint8_t tid,
+                                          WifiMacHeader::QosAckPolicy ackPolicy) const
+{
+  if (ackPolicy == WifiMacHeader::NORMAL_ACK)
+    {
+      // The given receiver must be the only one to send an immediate reply
+      if (stationsReplyingWithNormalAck.size () == 1
+          && stationsReplyingWithNormalAck.begin ()->first == receiver)
+        {
+          return true;
+        }
+
+      if (stationsReplyingWithBlockAck.size () == 1
+          && stationsReplyingWithBlockAck.begin ()->first == receiver)
+        {
+          return true;
+        }
+
+      return false;
+    }
+
+  if (ackPolicy == WifiMacHeader::BLOCK_ACK)
+    {
+      return true;
+    }
+
+  return false;
+}
+
+void
+WifiDlMuBarBaSequence::Print (std::ostream &os) const
+{
+  os << "DL_MU_BAR_BA_SEQUENCE [";
+  for (const auto& sta : stationsReplyingWithNormalAck)
+    {
+      os << " (ACK) " << sta.first;
+    }
+  for (const auto& sta : stationsReplyingWithBlockAck)
+    {
+      os << " (BA) " << sta.first;
+    }
+  for (const auto& sta : stationsSendBlockAckReqTo)
+    {
+      os << " (BAR+BA) " << sta.first;
+    }
+  os << "]";
+}
+
+
+/*
+ * WifiDlMuTfMuBar
+ */
+
+WifiDlMuTfMuBar::WifiDlMuTfMuBar ()
+  : WifiAcknowledgment (DL_MU_TF_MU_BAR),
+    ulLength (0)
+{
+}
+
+std::unique_ptr<WifiAcknowledgment>
+WifiDlMuTfMuBar::Copy (void) const
+{
+  return std::unique_ptr<WifiAcknowledgment> (new WifiDlMuTfMuBar (*this));
+}
+
+bool
+WifiDlMuTfMuBar::CheckQosAckPolicy (Mac48Address receiver, uint8_t tid,
+                                    WifiMacHeader::QosAckPolicy ackPolicy) const
+{
+  // the only admitted ack policy is Block Ack because stations need to wait for a MU-BAR
+  if (ackPolicy == WifiMacHeader::BLOCK_ACK)
+    {
+      return true;
+    }
+
+  return false;
+}
+
+void
+WifiDlMuTfMuBar::Print (std::ostream &os) const
+{
+  os << "DL_MU_TF_MU_BAR [";
+  for (const auto& sta : stationsReplyingWithBlockAck)
+    {
+      os << " (BA) " << sta.first;
+    }
+  os << "]";
+}
+
+
+/*
+ * WifiDlMuAggregateTf
+ */
+
+WifiDlMuAggregateTf::WifiDlMuAggregateTf ()
+  : WifiAcknowledgment (DL_MU_AGGREGATE_TF),
+    ulLength (0)
+{
+}
+
+std::unique_ptr<WifiAcknowledgment>
+WifiDlMuAggregateTf::Copy (void) const
+{
+  return std::unique_ptr<WifiAcknowledgment> (new WifiDlMuAggregateTf (*this));
+}
+
+bool
+WifiDlMuAggregateTf::CheckQosAckPolicy (Mac48Address receiver, uint8_t tid,
+                                        WifiMacHeader::QosAckPolicy ackPolicy) const
+{
+  // the only admitted ack policy is No explicit acknowledgment or TB PPDU Ack policy
+  if (ackPolicy == WifiMacHeader::NO_EXPLICIT_ACK)
+    {
+      return true;
+    }
+
+  return false;
+}
+
+void
+WifiDlMuAggregateTf::Print (std::ostream &os) const
+{
+  os << "DL_MU_AGGREGATE_TF [";
+  for (const auto& sta : stationsReplyingWithBlockAck)
+    {
+      os << " (BA) " << sta.first;
+    }
+  os << "]";
+}
+
+
+/*
+ * WifiUlMuMultiStaBa
+ */
+
+WifiUlMuMultiStaBa::WifiUlMuMultiStaBa ()
+  : WifiAcknowledgment (UL_MU_MULTI_STA_BA)
+{
+}
+
+std::unique_ptr<WifiAcknowledgment>
+WifiUlMuMultiStaBa::Copy (void) const
+{
+  return std::unique_ptr<WifiAcknowledgment> (new WifiUlMuMultiStaBa (*this));
+}
+
+bool
+WifiUlMuMultiStaBa::CheckQosAckPolicy (Mac48Address receiver, uint8_t tid,
+                                       WifiMacHeader::QosAckPolicy ackPolicy) const
+{
+  // a Basic Trigger Frame has no QoS ack policy
+  return true;
+}
+
+void
+WifiUlMuMultiStaBa::Print (std::ostream &os) const
+{
+  os << "UL_MU_MULTI_STA_BA [";
+  for (const auto& sta : stationsReceivingMultiStaBa)
+    {
+      os << "(" << sta.first.first << "," << +sta.first.second << ") ";
+    }
+  os << "]";
+}
+
+
+/*
+ * WifiAckAfterTbPpdu
+ */
+
+WifiAckAfterTbPpdu::WifiAckAfterTbPpdu ()
+  : WifiAcknowledgment (ACK_AFTER_TB_PPDU)
+{
+}
+
+std::unique_ptr<WifiAcknowledgment>
+WifiAckAfterTbPpdu::Copy (void) const
+{
+  return std::unique_ptr<WifiAcknowledgment> (new WifiAckAfterTbPpdu (*this));
+}
+
+bool
+WifiAckAfterTbPpdu::CheckQosAckPolicy (Mac48Address receiver, uint8_t tid,
+                                        WifiMacHeader::QosAckPolicy ackPolicy) const
+{
+  if (ackPolicy == WifiMacHeader::NORMAL_ACK)
+    {
+      return true;
+    }
+
+  return false;
+}
+
+void
+WifiAckAfterTbPpdu::Print (std::ostream &os) const
+{
+  os << "ACK_AFTER_TB_PPDU";
+}
+
+
+std::ostream & operator << (std::ostream &os, const WifiAcknowledgment* acknowledgment)
+{
+  acknowledgment->Print (os);
+  return os;
+}
+
+} //namespace ns3
